function zeta=ellc2(Ws,Eps)
% ############################################################################
%
% ellc2.m   zeta=ellc2(Ws,Eps) calculates the zeta of the second-order 
%           Cauer filter.
%           Ws  : normalized stopband edge frequency (unity cutoff frequency)
%           Eps : ripple - factor
%           ellc2.m returns zeta. The zeta=ellc2 is a function used to
%           calculate the poles of the Cauer filters of the order 
%           N= 2, 4, 6, 8, 12, 16, 18 (ellc.m).
%
%           M. Lutovac 6-18-1994
%
% function zeta=ellc2(Ws,Eps)
% ____________________________________________________________________________

T=sqrt(1-1/Ws^2);
zeta=2/((1+T)*sqrt(1+Eps^2)+sqrt((T-1)^2+Eps^2*(T+1)^2));
% ****************************************************************************


