function Z=ellca(N,Ws,epsilon)
% ############################################################################
%
% ellca.m   
%           Ws is the  normalized stopband edge frequency (unity cutoff)
%           Eps is ripple - factor
%           Z=ellca is a function used to calculate the transfer
%           function poles of the Cauer filters of the order 
%           N= 5, 7, 10, 11, 13, 15, 17 (ellz.m).
%
%           M. Lutovac 6-18-1994
%
% function Z=ellca(N,Ws,epsilon)
% ____________________________________________________________________________

Etol=epsilon/1000;   Rn=ellll(N,Ws); i=1;Y=1;    L=sqrt(1-1/Rn^2);
W=ellcz(i,Y,L); Eps=sqrt(1/W^2-1); DE=Eps-epsilon;
while abs(DE)>Etol
   if DE<0
      i=2*i;
   else
      i=2*i-1;
   end
   Y=Y+1;   W=ellcz(i,Y,L);   Eps=sqrt(1/W^2-1);   DE=Eps-epsilon;
end
L2=sqrt(1-1/Ws^2);
Z=ellcz(i,Y,L2);
% ****************************************************************************


