function Z=ellcz(i,Y,L)
% ############################################################################
%
% ellcz.m   
%           Z=ellcz is a function used to calculate the transfer
%           function poles of the Cauer filters of the order 
%           N= 5, 7, 10, 11, 13, 15, 17 (ellz.m).
%
%           M. Lutovac 6-18-1994
%
% function Z=ellcz(i,Y,L)
% ____________________________________________________________________________

R=[1/L 0];  T=[sqrt(1-L^2) 0];
I=[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]; I(Y+2:length(I))=[]; I(Y+1)=i;
for X=1:Y-1
   R(X+1)=(R(X)+sqrt(R(X)^2-1))^2;   T(X+1)=sqrt(1-1/R(X+1)^2);
   if I(Y+2-X)<=2^(Y-X)
      I(Y+1-X)=I(Y+2-X);
   else
      I(Y+1-X)=2^(Y+1-X)+1-I(Y+2-X);
   end
end
I(1)=1;  W=[0 0]; II=ones(I);
for ind=2:length(I)
   if I(ind)~=I(ind-1)
      II(ind-1)=-1;
   end
end
for X=1:Y-1
   W(X+1)=II(X)/sqrt(1+T(Y-X+1)*(1-W(X))/(1+W(X)));
end
Z=1/sqrt(1+T(1)*(1-W(Y))/(1+W(Y)));
if i>2^(Y-1)
   Z=-Z;
end
if i>2^Y
   Z=[];
   help ellcz, disp('  ')
   disp('  i <= 2^Y')
end
% ****************************************************************************


