function L2=elll2(Ws)
% ############################################################################
%
% elll2.m   L=elll2(Ws) calculates the absolute value of the second-order 
%           characteristic function of the Cauer filter.
%           Ws is normalized stopband edge frequency (unity cutoff frequency)
%           L=elll2 is a function used to calculate the poles of the 
%           Cauer filters of the order N= 4, 6, 8, 12, 16, 18 (ellc.m).
%
%           M. Lutovac 6-18-1994
%
% function L2=elll2(Ws)
% ____________________________________________________________________________

L2=(Ws+sqrt(Ws^2-1))^2;
% ****************************************************************************


