function L3=elll3(Ws)
% ############################################################################
%
% elll3.m   L=elll3(Ws) calculates the absolute value of the third-order 
%           characteristic function of the Cauer filter.
%           Ws is normalized stopband edge frequency (unity cutoff frequency)
%           L=elll3 is a function used to calculate the poles of the 
%           Cauer filters of the order N= 6, 9, 12, 18 (ellc.m).
%
%           M. Lutovac 6-18-1994
%
% function L3=elll3(Ws)
% ____________________________________________________________________________

S=Ws*Ws;
G=sqrt(4*S+(4*S*(S-1))^(2/3));
Z=2*S*sqrt(G)/(sqrt(8*S*(S+1)+12*G*S-G^3)-sqrt(G^3));
L3=Ws^3*(Z-1)^2/(Z-S)^2;
% ****************************************************************************


