function L=ellll(N,Ws)
% ############################################################################
% ellll.m   L=ellll(N,Ws) calculates the absolute value of the characteristic
%           function of the Cauer filter of the Nth order.
%           Ws is normalized stopband edge frequency (unity cutoff frequency)
%           M. Lutovac 6-18-1994
% function L=ellll(N,Ws)
% ____________________________________________________________________________

if N>0 & N<19
   if     N==1
      L=Ws;
   elseif N==2
      L=elll2(Ws);
   elseif N==3
      L=elll3(Ws);
   elseif N==4
      L=elll2(Ws);  L=elll2(L);
   elseif N==5
      L=elll3(Ws);  L=elll2(L);  L18=elll3(L);  L=elll2(L);  L24=elll2(L);
      L=((L18^2)*L24)^(1/3);     L=elll0p5(L);  L=elll0p5(L);
   elseif N==6
      L=elll3(Ws);  L=elll2(L);
   elseif N==7
      L=elll2(Ws);  L=elll2(L);  L12=elll3(L);  L=elll2(L);  L16=elll2(L);
      L=sqrt(L12*L16);           L=elll0p5(L);
   elseif N==8
      L=elll2(Ws);  L=elll2(L);  L=elll2(L);
   elseif N==9
      L=elll3(Ws);  L=elll3(L);
   elseif N==10
      L=elll3(Ws);  L=elll2(L);  L18=elll3(L);  L=elll2(L);  L24=elll2(L);
      L=((L18^2)*L24)^(1/3);     L=elll0p5(L);
   elseif N==11
      L=elll3(Ws);  L=elll2(L);  L18=elll3(L);  L=elll2(L);  L24=elll2(L);
      L=(L18*(L24^2))^(1/3);     L=elll0p5(L);
   elseif N==12
      L=elll3(Ws);  L=elll2(L);  L=elll2(L);
   elseif N==13
      L=elll2(Ws);  L=elll2(L);  L12=elll3(L);  L24=elll2(L12);
      L=elll2(L);   L=elll2(L);  L32=elll2(L);  L=sqrt(L24*L32);
      L14=elll0p5(L);            L=sqrt(L12*L14);
   elseif N==14
      L=elll2(Ws);  L=elll2(L);  L=elll2(L);    L24=elll3(L);  L=elll2(L);
      L32=elll2(L); L=sqrt(L24*L32);            L=elll0p5(L);
   elseif N==15
      L=elll2(Ws);  L=elll2(L);  L=elll2(L);    L24=elll3(L);  L16=elll2(L);
      L32=elll2(L16);  L=sqrt(L24*L32);  L14=elll0p5(L);    L=sqrt(L14*L16);
   elseif N==16
      L=elll2(Ws);  L=elll2(L);   L=elll2(L);   L=elll2(L);
   elseif N==17
      L2=elll2(Ws); L=elll3(L2);  L18=elll3(L);
      L=elll2(L2);  L=elll2(L);   L16=elll2(L); L=sqrt(L16*L18);
   elseif N==18
      L=elll3(Ws);   L=elll3(L);    L=elll2(L);
   end
else
   disp(' 1 < N < 19')
end
% ****************************************************************************
