function W=ellz30(Ws)
% ############################################################################
%
% ellz30.m  W=ellz30(Ws) finds a zero of the third-order characteristic
%           function of the Cauer filter.
%           Ws is the  normalized stopband edge frequency (unity cutoff)
%           The W=ellz30 is a function used to calculate the zeros of the 
%           Cauer filters of the order N= 3, 6, 9, 18 (ellc.m).
%
%           M. Lutovac 6-18-1994
%
% function W=ellz30(Ws)
% ____________________________________________________________________________

Ws2=Ws^2;
G=sqrt(4*Ws2+(4*Ws2*(Ws2-1))^(2/3));
W=sqrt((sqrt(8*Ws2*(Ws2+1)+12*G*Ws2-G^3)-sqrt(G^3))/2/sqrt(G));
% ****************************************************************************


