function W=ellz4(Ws)
% ############################################################################
%
% ellz4.m   W=ellz4(Ws) finds two zeros of the fourth-order characteristic
%           function of the Cauer filter.
%           Ws is the normalized stopband edge frequency (unity cutoff)
%           The W=ellz4 is a function used to calculate the zeros of the 
%           Cauer filters of the order N= 8, 12, 16 (ellc.m).
%
%           M. Lutovac 6-18-1994
% function W=ellz4(Ws)
% ____________________________________________________________________________

T=sqrt(1-1/Ws^2);
W=Ws*sqrt(1-sqrt(T))*[sqrt(1+T-sqrt(T+T^2)) sqrt(1+T+sqrt(T+T^2))];
% ****************************************************************************


