% Example_10_1.m
%  
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%       
% Design od the model filter
clear all, close all
[N,fk,mk,w]=firpmord([100,150],[1,0],[0.01,0.01],500);
fg = [0,100/250,150/250,1]; mk=[1,1,0,0];
g = firhalfband(22,100/250);
[G,w1]=freqz(g,1,1024);
figure (1)
plot(500*w1/(2*pi),20*log10(abs(G)));
xlabel('Frequency (Hz)'),ylabel('Gain(dB)'), title('Model filter')

% Generation of the periodic model filter 
gm = zeros(size(1:4*length(g)));
gm([1:4:length(gm)]) = g;
[Gm,w1]=freqz(gm,1,1024);
figure (2)
plot(2000*w1/(2*pi),20*log10(abs(Gm)));
xlabel('Frequency (Hz)'),ylabel('Gain(dB)')
axis([0,1000,-80,0])
title('Periodic model filter')

% Design of the masking filter
f0=[0,100/1000,375/1000,625/1000,875/1000,1]; m0=[1,1,0,0,0,0];
w0=[w',w(2)];
%ff=firpm(18,f0,m0,w0);
ff = firpm(18,f0,m0,[1,0.5,0.5]);
[F,w1]=freqz(ff,1,1024);
figure (3)
plot(2000*w1/(2*pi),20*log10(abs(F)));
xlabel('Frequency (Hz)'),ylabel('Gain(dB)'),title('Masking filter')
axis([0,1000,-80,0])

% Narrow-band filter characteristic
H=F.*Gm;
figure (4)
plot(2000*w1/(2*pi),20*log10(abs(H)));
xlabel('Frequency (Hz)'),ylabel('Gain(dB)')
title('Narrow-band filter')
axis([0,1000,-100,5])

figure (5)
subplot(3,1,1)
plot(2000*w1/(2*pi),20*log10(abs(Gm))); grid
ylabel('Gain, dB')
axis([0,1000,-60,5])
subplot(3,1,2)
plot(2000*w1/(2*pi),20*log10(abs(F))); grid
ylabel('Gain, dB')
axis([0,1000,-60,5])
subplot(3,1,3)
plot(2000*w1/(2*pi),20*log10(abs(H)));grid
xlabel('Frequency [Hz]'),ylabel('Gain, dB')
axis([0,1000,-60,5])
g(1)=axes('Position',[0.42 0.22 0.40 0.07]);
plot(2000*w1(1:102)/(2*pi),abs(H(1:102))), axis([0,100,0.99,1.011])
