% Example_10_4.m
%  
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
% Allpass branches
[b,a,z,p,k] = halfbandiir(5,0.4);  % Halfband filter design
beta2=(abs(p(2)))^2;    beta3=(abs(p(4)))^2;  % Coefficients of all-pass branches

[A0,w1]=freqz([beta2,0,1],[1,0,beta2],512);           % Model filter: all-pass branch A0(z)
[A1,w1]=freqz([0,beta3,0,1],[1,0,beta3],512);         % Model filter: all-pass brancg A1(z)
G=(A0+A1)/2; Gc=(A0-A1)/2;                            % Model filter G(z), and complementary model filter G_C(z)

% Design of masking filters
ap = 0.1; as = 40;
delta_p = (10^(ap/20)-1)/(10^(ap/20)+1); % Passband ripple
delta_s = 10^(-as/20);                   % Stopband ripple
freq = [0,0.6,0.85,1]; m0 = [1,1,0,0]; w = [delta_p/delta_s,1]; % Seting design parameters for masking filter f0
f0 = firpm(18,freq,m0,w);     % Designing the masking filter f0
f0 = [0,f0,0];
freq = [0,0.4,0.625,1]; m1=[1,1,0,0];  % Seting design parameters for masking filter f1
f1 = firpm(20,freq,m1,w);     % Designing the masking filter f1
[F0,w1]=freqz(f0,1,512);
[F1,w1]=freqz(f1,1,512);
%
%Generation of the periodic model filter
%[G0m,w1]=freqz([beta2,0,0,0,0,0,0,0,1],[1,0,0,0,0,0,0,0,beta2],512);
[A0m,w1]=freqz(upsample([beta2,0,1],4),upsample([1,0,beta2],4),512);  % Periodic model filter: all-pass branch A0(z^M)
[A1m,w1]=freqz(upsample([0,beta3,0,1],4),upsample([1,0,beta3],4),512); % Periodic model filter: all-pass branch A1(z^M)
Gm=(A0m+A1m)/2;    Gcm=(A0m-A1m)/2;          % Periodic model filter and complementary periodic model filter

% Implementation of the wide-band filter 
H=Gm.*F0+Gcm.*F1;
figure (1)
plot(2000*w1/(2*pi),20*log10(abs(H))); 
xlabel('Frequency [Hz]'),ylabel('Gain, dB')

axis([0,1000,-60,5])
hold on
plot([0,650,650,1000],[0,0,-40,-40],'--')
Fr=2000*w1/(2*pi);
g(1)=axes('Position',[0.20 0.55 0.40 0.07]);
plot(Fr(1:325),20*log10(abs(H(1:325)))),axis([0,600,-0.1,0.1])

