% Example_10_5
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all

[Hab,Hai,Hbb,Hbi,g,amax,amin,fp,f3db]=bkfil_all(7,1/2,0.2);
alpha = 2*fp
M=4
A=(conv(Hab,Hbi)+conv(Hbb,Hai))/2;
B=conv(Hai,Hbi);
[G,w]=freqz(A,B,512);
Ahp=(conv(Hab,Hbi)-conv(Hbb,Hai))/2;
[Ghp,w]=freqz(Ahp,B,512);

AA=zeros(size(1:4*length(A)-3));
AA(1:4:length(AA))=A;
BB=zeros(size(1:4*length(B)-3));
BB(1:4:length(BB))=B;
AAh=zeros(size(1:4*length(Ahp)-3));
AAh(1:4:length(AA))=Ahp;

[Gm,w]=freqz(AA,BB,512);
[Gmh,w]=freqz(AAh,BB,512);

f0=firgr(12,[0,alpha/M,0.5-alpha/M,1],[1,1,0,0]);
f0=[0,0,0,0,0,0,0,0,0,0,0,f0,0,0,0,0,0,0,0,0,0,0,0];
f1 = firhalfband(34,0.5-alpha/M);
[F0,w]=freqz(f0,1,512);
[F1,w]=freqz(f1,1,512);
H=Gm.*F0+Gmh.*F1;
figure (1)
plot(w/(pi),20*log10(abs(H)))
xlabel('\omega/\pi'),ylabel('Gain, dB')
axis([0,1,-60,5])
hold on
plot([0,0.4,0.4315,1],[0,0,-43,-43],'--')
Fr=2*w/(2*pi);
g(1)=axes('Position',[0.55 0.55 0.30 0.07]);
plot(Fr(1:325),20*log10(abs(H(1:325)))),axis([0,0.400,-0.1,0.1])
figure (2)
subplot(3,1,1)
plot(w/(pi),20*log10(abs(G))),ylabel('Gain, dB')
axis([0,1,-60,5])
hold on
plot(w/(pi),20*log10(abs(Ghp)),'--')
subplot(3,1,2)
plot(w/(pi),20*log10(abs(Gm)),w/(pi),20*log10(abs(Gmh)),'--b')
ylabel('Gain, dB')
axis([0,1,-60,5])
subplot(3,1,3)
plot(w/(pi),20*log10(abs(F0)),w/(pi),20*log10(abs(F1)),'--b')
xlabel('\omega/\pi'),ylabel('Gain, dB')
axis([0,1,-60,5])
